org.apache.solr.schema

## Class TrieDateField

- java.lang.Object
- - org.apache.solr.schema.FieldProperties
  - - org.apache.solr.schema.FieldType
    - - org.apache.solr.schema.PrimitiveFieldType
      - - org.apache.solr.schema.TrieField
        - - org.apache.solr.schema.TrieDateField

- All Implemented Interfaces:
    DateValueFieldType

      public class TrieDateField
      extends TrieField
      implements DateValueFieldType

  FieldType that can represent any Date/Time with millisecond precision.

  Date Format for the XML, incoming and outgoing:

  > A date field shall be of the form 1995-12-31T23:59:59Z The trailing "Z" designates UTC time and is mandatory (See below for an explanation of UTC). Optional fractional seconds are allowed, as long as they do not end in a trailing 0 (but any precision beyond milliseconds will be ignored). All other parts are mandatory.

  This format was derived to be standards compliant (ISO 8601) and is a more restricted form of the canonical representation of dateTime from XML schema part 2. Examples...

  - 1995-12-31T23:59:59Z
  - 1995-12-31T23:59:59.9Z
  - 1995-12-31T23:59:59.99Z
  - 1995-12-31T23:59:59.999Z

  Note that TrieDateField is lenient with regards to parsing fractional seconds that end in trailing zeros and will ensure that those values are indexed in the correct canonical format.

  This FieldType also supports incoming "Date Math" strings for computing values by adding/rounding internals of time relative either an explicit datetime (in the format specified above) or the literal string "NOW", ie: "NOW+1YEAR", "NOW/DAY", "1995-12-31T23:59:59.999Z+5MINUTES", etc... -- see `DateMathParser` for more examples.

  NOTE: Although it is possible to configure a `TrieDateField` instance with a default value of "`NOW`" to compute a timestamp of when the document was indexed, this is not advisable when using SolrCloud since each replica of the document may compute a slightly different value. `TimestampUpdateProcessorFactory` is recommended instead.

  Explanation of "UTC"...

  > "In 1970 the Coordinated Universal Time system was devised by an international advisory group of technical experts within the International Telecommunication Union (ITU). The ITU felt it was best to designate a single abbreviation for use in all languages in order to minimize confusion. Since unanimous agreement could not be achieved on using either the English word order, CUT, or the French word order, TUC, the acronym UTC was chosen as a compromise."

  See Also:
    `TrieField`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.solr.schema.TrieField

      `TrieField.TrieTypes`

    - ### Nested classes/interfaces inherited from class org.apache.solr.schema.FieldType

      `FieldType.DefaultAnalyzer, FieldType.MultiValueSelector`

  - ### Field Summary

    - ### Fields inherited from class org.apache.solr.schema.TrieField

      `DEFAULT_PRECISION_STEP, precisionStep, precisionStepArg, type`

    - ### Fields inherited from class org.apache.solr.schema.FieldType

      `ANALYZER, args, CHAR_FILTER, CHAR_FILTERS, CLASS_NAME, docValuesFormat, falseProperties, FILTER, FILTERS, INDEX, INDEX_ANALYZER, MULTI_TERM, MULTI_TERM_ANALYZER, POLY_FIELD_SEPARATOR, postingsFormat, properties, QUERY, QUERY_ANALYZER, similarity, SIMILARITY, similarityFactory, TOKENIZER, trueProperties, TYPE, TYPE_NAME, typeName`

    - ### Fields inherited from class org.apache.solr.schema.FieldProperties

      `BINARY, DOC_VALUES, INDEXED, MULTIVALUED, OMIT_NORMS, OMIT_POSITIONS, OMIT_TF_POSITIONS, REQUIRED, SORT_MISSING_FIRST, SORT_MISSING_LAST, STORE_OFFSETS, STORE_TERMOFFSETS, STORE_TERMPAYLOADS, STORE_TERMPOSITIONS, STORE_TERMVECTORS, STORED, TOKENIZED, USE_DOCVALUES_AS_STORED`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TrieDateField()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `toNativeType(Object val)` Converts any Object to a java Object native to this field type
    `Date` | `toObject(IndexableField f)` Convert the stored-field format to an external object.

    - ### Methods inherited from class org.apache.solr.schema.TrieField

      `checkSchemaField, createField, createFields, getFieldQuery, getMainValuePrefix, getNumericType, getPrecisionStep, getRangeQuery, getSingleValueSource, getSingleValueSource, getSortField, getType, getUninversionType, getValueSource, indexedToReadable, indexedToReadable, init, isTokenized, multiValuedFieldCache, readableToIndexed, readableToIndexed, storedToIndexed, storedToReadable, toExternal, toInternal, toObject, write`

    - ### Methods inherited from class org.apache.solr.schema.FieldType

      `createField, getAnalyzerProperties, getClassArg, getDocValuesFormat, getIndexAnalyzer, getIndexOptions, getNamedPropertyValues, getNonFieldPropertyArgs, getPostingsFormat, getPrefixQuery, getQueryAnalyzer, getRewriteMethod, getSimilarity, getSimilarityFactory, getStringSort, getTypeName, hasProperty, isExplicitAnalyzer, isExplicitQueryAnalyzer, isMultiValued, isPolyField, marshalBase64SortValue, marshalSortValue, marshalStringSortValue, restrictProps, setArgs, setIndexAnalyzer, setIsExplicitAnalyzer, setIsExplicitQueryAnalyzer, setQueryAnalyzer, setSimilarity, supportsAnalyzers, toString, unmarshalBase64SortValue, unmarshalSortValue, unmarshalStringSortValue, useDocValuesAsStored`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### TrieDateField

          public TrieDateField()

  - ### Method Detail

    - #### toObject

          public Date toObject(IndexableField f)

      Description copied from class: `FieldType`
      Convert the stored-field format to an external object.
      Overrides:
        `toObject` in class `TrieField`
      See Also:
        `FieldType.toInternal(java.lang.String)`

    - #### toNativeType

          public Object toNativeType(Object val)

      Description copied from class: `FieldType`
      Converts any Object to a java Object native to this field type
      Overrides:
        `toNativeType` in class `FieldType`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.